# -*- coding: japanese-cp932 -*-

require "open-uri"
require "thread"

def get_flv(course_code)
  if COURSE_DATA[course_code]["idx"] != 8 then
    get_flv_gogaku(course_code)
  else
    get_flv_charo(course_code)
  end
end


def get_flv_gogaku(course_code)
  $MAGIC_DIGITS = open("http://nhk-rtmp-capture.googlecode.com/svn/trunk/MAGIC-DIGITS.TXT").gets.chop
  dir_n   = COURSE_DATA[course_code]["name"]
  xml_uri =  COURSE_DATA[course_code]["base_url"] +"/"+ $MAGIC_DIGITS + "/" + XML_F
  xml = OpenURI.open_uri(xml_uri).read
  unless xml.match(/^\<musicdata\>/) then
     puts "擾ꂽXMLt@C܂B"
     if STDIN.gets then exit end
  end
  doc = REXML::Document.new xml
  m = Mutex.new
  doc.elements.each("musicdata/music") do |e|
    Thread.start do
      m.synchronize do
        out_flv_dir = "flv/"+ dir_n
        unless( FileTest.exist? out_flv_dir ) then
          FileUtils.mkdir_p out_flv_dir
        end
        flv_n = e.attributes["file"]
        out_flv = out_flv_dir + "/" + flv_n
        log_info = (e.attributes["kouza"] + " " + e.attributes["hdate"]).tosjis
        if($text) then
          $text.text +=  log_info + "FLVLv`...\r\n"
          $text.scrollTo($text.countLines,1)
        end
        unless( FileTest.exist? out_flv ) then
          cmd = RTMPDUMP + " -o #{out_flv} -r #{URL_BASE}/#{$MAGIC_DIGITS}/#{flv_n}"
          stdin, stdout, stderr = exec_stub(cmd)
          if $pb then
            $pb.position = 0
            while l = stderr.gets("\r") do
              if l.match(/^([0-9\.]+) KB \(([0-9\.]+)%\)/) then
                $pb.position = $2.to_i
              end
            end
          else
            while l = stderr.gets("\r") do
              print l + "\r"
            end
          end
        end
        
        if(FileTest.exist? out_flv) then
          out_mp3_dir = "mp3/" + dir_n
          unless( FileTest.exist? out_mp3_dir ) then
            FileUtils.mkdir_p out_mp3_dir
          end
          if $text then
            $text.text += log_info +"MP3ɕϊ...\r\n"
            $text.scrollTo($text.countLines,1)
          end
          
          mp3_n = log_info + ".mp3"
          if (mp3_n.match(/(\d{1})(\d{1})/)) then
             mp3_n = mp3_n.gsub(/(\d{1})(\d{1})/, sprintf("%02d%02d", $1.to_i, $2.to_i))
          end
          album = e.attributes["kouza"].tosjis
          title = e.attributes["hdate"].tosjis
          if (title.match(/(\d{1})(\d{1})/)) then
             title = title.gsub(/(\d{1})(\d{1})/, sprintf("%02d%02d", $1.to_i, $2.to_i))
          end
          out_mp3 = out_mp3_dir + "/" + mp3_n
          unless( FileTest.exist? out_mp3 ) then
            cmd = FFMPEG + " -i #{out_flv} -acodec copy \"#{out_mp3}\""
            $pb.position = 0 if $pb
            stdin, stdout, stderr = exec_stub(cmd)
            if $pb then
              while l = stderr.gets do
              end
              $pb.position = 100
            else
              while l = stderr.gets do
                print l
              end
            end
            tag = ID3Lib::Tag.new(out_mp3)
            tag.title = title
            tag.album = album
            tag.artist = "NHK"
            tag.update!
          end
        end
      end
    end
  end
  Thread.start do 
    m.synchronize do 
      if $text then
        $text.text += "!_(^o^)^"
        $text.scrollTo($text.countLines,1)
        $pb.position = 0
      end
    end
  end
end


def get_flv_charo(course_code)
  dir_n = COURSE_DATA[course_code]["name"]
  xml_uri =  COURSE_DATA[course_code]["base_url"] +"/xml/radio.xml"
  xml = OpenURI.open_uri(xml_uri).read
  doc = REXML::Document.new xml
  m = Mutex.new
  doc.elements.each("streaming/items/item") do |e|
    Thread.start do
      m.synchronize do
        out_flv_dir = "flv/"+ dir_n
        unless( FileTest.exist? out_flv_dir ) then
          FileUtils.mkdir_p out_flv_dir
        end
        flv_n = e.elements["flv"].text
        out_flv = out_flv_dir + "/" + flv_n
        log_info = dir_n + " " + (e.elements["label"].text).to_s.tosjis
        if($text) then
          $text.text +=  log_info + "FLVLv`...\r\n"
          $text.scrollTo($text.countLines,1)
        end
        unless( FileTest.exist? out_flv ) then
          cmd = RTMPDUMP + " -o #{out_flv} -r #{URL_BASE_CHARO}/#{flv_n}"
          stdin, stdout, stderr = exec_stub(cmd)
          if $pb then
            $pb.position = 0
            while l = stderr.gets("\r") do
              if l.match(/^([0-9\.]+) KB \(([0-9\.]+)%\)/) then
                $pb.position = $2.to_i
              end
            end
          else
            while l = stderr.gets("\r") do
              print l + "\r"
            end
          end
        end
        
        if(FileTest.exist? out_flv) then
          out_mp3_dir = "mp3/" + dir_n
          unless( FileTest.exist? out_mp3_dir ) then
            FileUtils.mkdir_p out_mp3_dir
          end
          if $text then
            $text.text += log_info +"MP3ɕϊ...\r\n"
            $text.scrollTo($text.countLines,1)
          end
          
          mp3_n = log_info + ".mp3"
          album = dir_n
          title = dir_n + " " + e.elements["label"].text.tosjis
          out_mp3 = out_mp3_dir + "/" + mp3_n
          unless( FileTest.exist? out_mp3 ) then
            cmd = FFMPEG + " -i #{out_flv} -acodec copy \"#{out_mp3}\""
            $pb.position = 0 if $pb
            stdin, stdout, stderr = exec_stub(cmd)
            if $pb then
              while l = stderr.gets do
              end
              $pb.position = 100
            else
              while l = stderr.gets do
                print l
              end
            end
            tag = ID3Lib::Tag.new(out_mp3)
            tag.title = title
            tag.album = album
            tag.artist = "NHK"
            tag.update!
          end
        end
      end
    end
  end
  Thread.start do 
    m.synchronize do 
      if $text then
        $text.text += "!_(^o^)^"
        $text.scrollTo($text.countLines,1)
        $pb.position = 0
      end
    end
  end
end
